\subsection*{Weight adjustement}

The weight adjustment is of the form
\eqline{w_k \leftarrow \hat{w}_k + \upsilon \, \delta w_k}
where $\hat{w}_k$ is the previous weight estimation, while
\eqline{\delta w_k \deq l_k \, \sum_{nt} z_n(t) \, \partial_{w_k}{}_{\bf w}f_n(t, \cdots)}
is obtained combining the locally quadratic regularization and adjustment weight gradient, while $\upsilon$ is to be auto-tuned.

It must be noted that the regularization term $\|{\bf w} - \hat{\bf w}\|_{{\bf \Lambda}(\hat{\bf w}, \hat{\bf x}, \hat{\bf z})^{-1}}^2$ is only ``locally'' quadratic in the sense that after each step the quadratic form is adjusted given the obtained estimation, allowing the criterion to consider more general regularization terms, as \href{https://line.gitlabpages.inria.fr/aide-group/backwardtuning/quadlin.pdf}{\underline{quadlin}} regularization or ${\cal L}^p$, $1 < p \le 2$ regularization.

The $\upsilon$ global weight adjustment gain is auto-tuned using a very common basic heuristic:
\begin{lstlisting}
  While(upsilon < epsilon) {
    Adjust the weights
    Estimate the new criterion cost
    If the cost does not decrease
      upsilon is divided by 2
    Else
      upsilon is slightly increased
  }
\end{lstlisting}
where `epsilon` depends on the floating point precision, usually taken as the square root of the floating precision, or can be application dependent
\\ while `upsilon` is slightly increased by a factor of the golden ratio ($\simeq 1.62$) in our implementation, without any special rational for this choice: the important point is that it can not be a power of 2 (e.g. $\sqrt{2}$) to be sure not to explore the same values.


